const Extension = imports.ui.extensionSystem.extensions["gmail_notify@jablona123.pl"];
const TlsConn=Extension.tlsconnection;
const Imap = Extension.imap;
const Signals=imports.signals;
const Lang=imports.lang;
const OAuth=Extension.oauth;
const Goa = imports.gi.Goa;
const _DEBUG=false;


var GmailConnection = function () {
	this._init.apply(this,arguments);
}

GmailConnection.prototype = {
	__proto__: TlsConn.TlsConnection.prototype,
	_init : function (account) {
		try 
		{
			if (account.get_account().provider_name.toUpperCase()!= "GOOGLE"){
				throw new Error('This is not Google Account')
			}
			this._oAccount=account;
			if (_DEBUG) global.log("Creating gmail conn .."+this._oAccount.get_account().id);
			this._oMail=this._oAccount.get_mail();				
			TlsConn.TlsConnection.prototype._init.call(this,this._oMail.imap_host,this._oMail.imap_use_tls ? 993 : 143)
		}
		catch (err) 
		{
			global.log("gmailConnection.proto:"+err.message);
		}
	}
	
};

function GmailImap () {
	this._init.apply(this,arguments);	
}
GmailImap.prototype= {
	__proto__:Imap.Imap.prototype,
	_init : function (conn) {
		try {
		if (conn instanceof GmailConnection) {
			Imap.Imap.prototype._init.call(this,conn) ;
		}
		// must be goa object (account)
		else  {
			let oconn = new GmailConnection(conn);
			Imap.Imap.prototype._init.call(this,oconn) ;
			if (_DEBUG) global.log("Imap created: .."+this._conn._oAccount.get_account().id);
		}
		this.authenticated=false;				
		this._conn.connect('disconnected',Lang.bind(this,function(){
			this.authenticated = false;
			}))
		}
		catch (err) 
		{
			global.log("gmailImap.proto:"+err.message);
		}
	},
	readGreeting : function (callback) {
		this._readBuffer("",true,true,Lang.bind(this,function (oImap,resp) {				
				if (resp[0].substr(2,2)=="OK") this.gmailConnected=true;											
					this.emit('greeting-ready');					
					if (typeof(callback) !=	'undefined') {							
							callback.apply(this,[this,resp]);
					}
				} ));											
				
	},
	
	authenticate: function(account,service,callback) {
		
	try {
		if (this._conn.connected) 
		{	
			this._doauthenticate(account,service,callback)
		} 
		else 
		{
			var _acc=account;
			var _svr=service;
			var _call=callback;
			this._conn._connect(Lang.bind(this,function () {
				this._doauthenticate(_acc,_svr,_call)
				}));
		}
		}	
		catch (err) {
			global.log("authenticate: "+err.message)
		}						
	},
	_doauthenticate : function (account,service,callback) {
		try {
		let oAuth=new OAuth.OAuth(account,service);
		let auth_str=oAuth.oAuth_str;
		this._command("AUTHENTICATE XOAUTH "+auth_str,false,Lang.bind(this,function (oGIMap,resp) {
					if (_DEBUG) {for (let i=0;i<resp.length;i++) global.log(resp[i]);}
					if (this._commandOK(resp)){
						this.authenticated=true;		
						this._conn.newline=String.fromCharCode(13)+String.fromCharCode(10);
						if (typeof(callback) !=	'undefined') {
							callback.apply(this,[this,resp]);
						}
						this.emit('authenticated',true);						
					}
					else {
						if (typeof(callback) !=	'undefined') {
							callback.apply(this,[this,resp,new Error('Authentication error')]);
						}
						this.emit('authenticated',false);	
					}				
				} )
		);
		}	
		catch (err) {
			global.log("_doAuthenticate: "+err.message)
		}
	},
	scanInbox : function (callback) {
		try {
		if (this.authenticated ) {
			this._doScanInbox(callback);
		}
		else 
		{
			var _call=callback;
			
			this.authenticate(this._conn._oAccount,"https://mail.google.com/mail/b/"+this._conn._oMail.imap_user_name+"/imap/",
				Lang.bind(this,function(){
					this._doScanInbox(_call);
				}))		
		}	
		}	
		catch (err) {
			global.log("scanInbox: "+err.message)
		}
	},
	_doScanInbox: function (callback,i) {
		try {
		if (_DEBUG) global.log("doScan entry")
		this._scanFolder("INBOX",Lang.bind(this,function(oImap,resp,error){
						if (_DEBUG) global.log("doScan callback i=");
							try {
							if (typeof(callback) !=	'undefined') {
								if (typeof(error) == 'undefined') 
								{									
									callback.apply(this,[this,resp]);
									
								}
								else {
									
									callback.apply(this,[this,resp,error]);
								}
								
							}
							if (_DEBUG) global.log("doScan"+this.folders.length);
							
							this.emit('inbox-scanned',resp,error)		
							}
							catch (err) {
								global.log("doScan :"+err.message)
							}
							}));
		}	
		catch (err) {
			global.log("_doscanInbox: "+err.message)
		}
							
	}
}

Signals.addSignalMethods(GmailImap.prototype);

