const Extension = imports.ui.extensionSystem.extensions["gmail_notify@jablona123.pl"];
const Sha =Extension.sha;
//const Sha =imports.sha;
const Signals=imports.signals;
const GLib=imports.gi.GLib;
const _DEBUG =false;

var OAuth=function(account,method,service) {
	this._init(account,method,service);
}
OAuth.prototype= {
_init	: function (account,service,method) {
	this.account = account ;
	this.method = typeof(method) != 'undefined' ? method : "GET";
	this.service =  service;
	this.oAuth = account.get_oauth_based();
	this.oAcc = account.get_account();
	this.acc_token=this.oAuth.call_get_access_token_sync(null);
	
	this.error=null;
	this._makeStrings();
	},
	
	
_initStrings : function () {
	this.oAuth_base=escape(this.method)+"&"+encodeURIComponent(this.service)+"&";
	this.oAuth_req=this.method+" "+this.service+" ";
	
},
_setNonce : function() {
	this.nonce=""; for (let j=1;j<=18;j++) this.nonce+=Math.floor(Math.random()*11).toString();	
	let dt=new Date(); 
	this.timestamp=(dt.getTime()/1000).toFixed(0).toString();
	},
_makeStrings : function () {
			
			//https://mail.google.com/mail/b/"+_email+"/imap/
			try {
			this._initStrings();
			this._setNonce();
			let anames  =  ["oauth_consumer_key","oauth_nonce","oauth_signature_method","oauth_timestamp","oauth_token"                     ,"oauth_version"];
			let avalues =  [this.oAuth.consumer_key , this.nonce       , "HMAC-SHA1"            ,this.timestamp        , encodeURIComponent(this.acc_token[1]),"1.0"]
			let avalues1 = [this.oAuth.consumer_key , this.nonce       , "HMAC-SHA1"            ,this.timestamp        , this.acc_token[1]                    ,"1.0"]			
			for (let i=0;i<anames.length;i++) {
				this.oAuth_base+= encodeURIComponent(( i > 0 ? "&":"") +anames[i]+"="+avalues[i]);
				this.oAuth_req += anames[i]+"=\""+avalues1[i]+"\",";
			}			
				if (_DEBUG) global.log("Oauth Signature base:" + this.oAuth_base);
			
			this.oAuth_sigKey=escape(this.oAuth.consumer_secret)+"&"+encodeURI(this.acc_token[2]);
				if (_DEBUG) global.log("Oauth Signature key:" + this.oAuth_sigKey);
		
			//now hmac sha-1 signature base with key			
			let shaObj = new jsSHA(this.oAuth_base, "ASCII");				
			let hmac = shaObj.getHMAC(this.oAuth_sigKey, "ASCII", "SHA-1", "B64");
				if (_DEBUG) global.log("Oauth Signature hmac:" + hmac);
				
			this.oAuth_req+="oauth_signature=\""+hmac+"\"";
				if (_DEBUG) global.log("auth_req:" + this.oAuth_req);
			
			this.oAuth_str=GLib.base64_encode(this.oAuth_req);
				if (_DEBUG) global.log("auth_str:" +this.oAuth_str);
			this.error=null;
			}
			
			catch (err) 
			{
				global.log(err.message);
				this.emit('error',err);
				this.error=err;
			}
			
		} 
};

try {
	Signals.addSignalMethods(OAuth.prototype);
} 
catch (err) {
	global.log(err.message);
}
